#!/usr/bin/python
# -*- coding: utf-8 -*-

import Slowo, wav

def inter(a, b):
	
	""" Bierze dwie głoski a i b, w domyśle występujące na końcu i na początku wyrazów
		stojących obok siebie we frazie. Zwraca je po zajściu (lub nie) upodobnienia międzywyrazowego """
																										
	
	if a.dzwieczna != b.dzwieczna and not (
			a.stopien_zblizenia in [u'półsamogłoskowa',u'drżąca', u'nosowa', u'boczna'] or 
				b.stopien_zblizenia in [u'półsamogłoskowa',u'drżąca', u'nosowa', u'boczna']):
		a.zmien_dzwiecznosc()
	return a,b

class Fraza:
	def __init__(self, phrase, filename=None):
		self.fraza = map(lambda word: Slowo.Slowo(word), phrase.lower().strip().split())
		
		# upodobnienia międzywyrazowe
		for i in range(len(self.fraza)-1):
			(self.fraza[i][-1],self.fraza[i+1][0]) = inter (self.fraza[i][-1],self.fraza[i+1][0])
			
		self.bytes = ""
		self.filename = None
		
		#jeśli w konstruktorze została podana nazwa pliku, od razu dokonujemy syntezy
		if filename:
			self.write(filename)
		
	def get_bytes(self):
		for S in self:
			self.bytes += S.get_bytes()
		return self.bytes
		
	def write(self,filename):
		""" Zapisuje reprezentację dźwiękową frazy do pliku filename """
		
		if len(self.bytes) == 0: self.get_bytes()
		F = wav.create_wave(filename, self.bytes)
		self.filename = filename
		return filename
			
	def __iter__(self):
		return self.fraza.__iter__()
			
	def __getitem__(self,i):
		return self.fraza[i]
			
	def __repr__(self):
		return str(self.fraza)
			
	def __str__(self):
		return ' '.join(map(lambda x:str(x), self.fraza))